package mi.hdm.typeAdapters;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import mi.hdm.recipes.Category;
import mi.hdm.recipes.CategoryManager;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CategoryManagerTypeAdapter extends TypeAdapter<CategoryManager> {
    @Override
    public void write(JsonWriter writer, CategoryManager categoryManager) throws IOException {
        writer.beginObject();
        writer.name("categories").jsonValue(new GsonBuilder()
                .registerTypeAdapter(Category.class, new CategoryTypeAdapter())
                .create()
                .toJson(categoryManager.getAllCategories()));
        writer.endObject();
    }

    @Override
    public CategoryManager read(JsonReader reader) throws IOException {
        List<Category> categories = new ArrayList<>();
        reader.beginObject();
        while (reader.hasNext()) {
            String propertyName = reader.nextName();
            if (propertyName.equals("categories")) {
                CategoryTypeAdapter typeAdapter = new CategoryTypeAdapter();
                reader.beginArray();
                Gson gson = new GsonBuilder()
                        .registerTypeAdapter(Category.class, typeAdapter)
                        .create();
                while (reader.hasNext()) {
                    Category next = gson.fromJson(reader, Category.class);
                    categories.add(next);
                }
                reader.endArray();
            }
        }
        reader.endObject();
        return new CategoryManager(categories);
    }
}
